;**********************************************************************************************
; Autor: Sven Stoecker,	LCD-Ausgabe von Dirk Stoecker
;  V 0.1   2002-03-02: first non-working version
;  V 0.2   2002-03-15: Displayansteuerung + RS 232 in i.O
;  V 0.3   2002-07-xx: einige Hardware und Rechenfunktionen hinzugefuegt
;  V 0.4   2003-02-xx: Berechnung Ausgabe der PWM fuer Pumpe ohne Limit
;  V 0.5   2003-08-26: Routinen zur Abfrage der Taster
;  V 0.6   2003-09-12: Routinen zur Textanzeige aus dem Programmspeicher
;  V 0.7   2003-09-27: I2C fuer 24xxx Datenspeicherung
;  V 0.8   2003-10-06: Ordentliches Timerkonzept, Erzeugung der GluehPWM, Systemzeit
;  V 0.9   2003-10-18: Menue zur Parametereingabe, EEPRom routinen, kleinere Aenderungen
;**********************************************************************************************

	.include "4433def.inc"

;**********************************************************************************************
; Variablen und Zuweisungen
;**********************************************************************************************

.def    textV			= r01		; Zaehler fuer Lauftextgeschwindigkeit
.def	I2C_data		= r02		; Daten bei I2C Datenuebertragung
.def    textpos			= r04		; Position vom Lauftext
.def	TIMERHI 		= r05		; Systemzeit
.def	MesswertHI		= r06		; Zwischenspeicher fuer Servo und Drehzahlmessung
.def	MesswertLO		= r07		; Zwischenspeicher fuer Servo und Drehzahlmessung
.def	Messkontrollzaehler	= r08
.def	ServomessHI		= r09
.def	ServomessLO		= r10
.def   	temp    		= r16		; temporary variable
.def	temp2			= r17		; temporary variable
.def	temp3			= r18		; temporary variable
.def	sendbuf			= r19		; buffer fuer Senden 
.def	ECU_Status		= r20	
.equ		Men			=0
;equ		Pumpe			=1
.equ		Rechen			=2
.equ		Messtest		=3
;equ					=4
.equ		ServoiO			=5
.equ		DrehiO			=6
.equ		Drehmess		=7
.def	Itemp 			= r22		; Temp fuer Interupt
.def	Itemp2			= r23
.def	ZeitHI			= r24
.def	ZeitLO  		= r25		; Systemzeit

;**********************************************************************************************
; Zuweisungen fuer das LCD_Display
;**********************************************************************************************

.equ   	LIGHT 		=3
.equ	ENABLE		=4
.equ	RS		=5

.equ	DISP_CLEAR	= 0b00000001
.equ	CURS_HOME	= 0b00000010
.equ	ENTRYMODE	= 0b00000100 ;(set following 2*2 subtypes)
.equ     MODE_INC       = 0b00000010
.equ     MODE_DEC       = 0b00000000
.equ     MODE_SHIFT     = 0b00000001
.equ     MODE_FREEZE    = 0b00000000
.equ    DISPLAYMODE     = 0b00001000 ;(set following 3*2 subtypes)
.equ     DMODE_DISPON   = 0b00000100
.equ     DMODE_DISPOFF  = 0b00000000
.equ     DMODE_CURSON   = 0b00000010
.equ     DMODE_CURSOFF  = 0b00000000
.equ     DMODE_BLINK    = 0b00000001
.equ     DMODE_NOBLINK  = 0b00000000
.equ    DISPLAYSHIFT    = 0b00010000 ;(set following 2*2 subtypes)
.equ     SHIFT_DISPLAY  = 0b00001000
.equ     SHIFT_CURSOR   = 0b00000000
.equ     SHIFT_RIGHT    = 0b00000100
.equ     SHIFT_LEFT     = 0b00000000
.equ    FUNCTIONSET     = 0b00100000 ;(set following 3*2 subtypes)
.equ     SET_8BIT       = 0b00010000
.equ     SET_4BIT       = 0b00000000
.equ     SET_2LINE      = 0b00001000
.equ     SET_1LINE      = 0b00000000
.equ     SET_5X10       = 0b00000100
.equ     SET_5X8        = 0b00000000
.equ    CGRAMADDRESS    = 0b01000000
.equ    DDRAMADDRESS    = 0b10000000
.equ    LINE1		= 0b10000000
.equ    LINE2		= 0b11000000
.equ    LINE3		= 0b10010000
.equ    LINE4		= 0b11010000
.equ	Zeichenram	= 0b01000000

;**********************************************************************************************
; Adresswort I2C 24C65
;**********************************************************************************************

.equ	EE24xxx_w	= 0b10100000
.equ	EE24xxx_r	= 0b10100001

;**********************************************************************************************
; Belegung der Ports 
;**********************************************************************************************

; PORTB0		I2C		SCL
; PORTB1		Pumpe
; PORTB2		I2C		SDA
; PORTB3		Display 	Beleuchtung
; PORTB4		Display6	(Enable)
; PORTB5		Display4	(RS)

; PORTC0		Gas		0=aus		1=an
; PORTC1		Starter		0=aus		1=an
; PORTC2		Glh		0=aus		1=an
; PORTC3		Taster		1=inaktiv	0=aktiv
; PORTC4/AD4		Ackuspannung
; PORTC5/AD5		Temperatur

; PORTD0		RxD
; PORTD1		TxD
; PORTD2		Drehzahl	Int0
; PORTD3		Servo		Int1
; PORTD4		Display11
; PORTD5		Display12
; PORTD6		Display13
; PORTD7		Display14

;**********************************************************************************************
; Belegung des EEPROM
;**********************************************************************************************

.eseg

		.dw	0x0000			;
		.dw	0x0000			;Men1
		.dw	0x044c			;Men2	Rx aus
		.dw	0x04b0			;Men3	Rx leer
		.dw	0x07d0			;Men4	RX voll
		.dw	0x0019			;Men5	rpm aus
		.dw	0x0023			;Men6	rpm min
		.dw	0x007d			;Men7	rpm max
		.dw	0x0008			;Men8	rpm Rampe
		.dw	0x009a			;Men9  Pumpe Start
		.dw	0x00e6			;Men10	Pumpe min
		.dw	0x01f4			;Men11 Pumpe max
		.dw	0x0012			;Men12 Pumpe Rampe
		.dw	0x0032			;Men13	Temp Start
		.dw	0x0320			;Men14	Temp max
		.dw	0x0000			;Men15 Tank
		.dw	0x0000			;Men16 Verbrauch
		.dw	0x0002			;Men17 Imp/Umdrehung
		.dw	0x00c8			;Men18 Glhspannung
		
;**********************************************************************************************
; Belegung des SRAMS
;**********************************************************************************************

.equ	DrehzahlLO	=0x60		;
.equ	DrehzahlHI	=0x61
.equ	ServoLO		=0x66
.equ	ServoHI		=0x67
.equ	DrehLO		=0x68
.equ	DrehHI		=0x69
.equ	TempLO		=0x6a
.equ	TempHI		=0x6b
.equ	AckuLO		=0x6c
.equ	AckuHI		=0x6d
.equ	Taster		=0x6e		; enthaelt die letzte Tasterposition
.equ	Menzeile	=0x77
.equ	Gluehwert	=0x78
.equ	Zeitzaehler	=0x79
.equ	PumpeLO		=0x7a		; Zwischenspeicher fuer Pumpenspannung
.equ	PumpeHI		=0x7b
;**********************************************************************************************
; Beginn des Codesbereiches
;**********************************************************************************************

.cseg
.org $0000

;**********************************************************************************************
; Interupt-Sprungtabelle
;**********************************************************************************************

			rjmp	Start			; RESET
			rjmp	Drehmessung		; Drehzahl
			rjmp	Servomessung		; Servo
			reti				; TIMER1 CAPT
			reti				; TIMER1 COMP
			reti				; TIMER1 OVF
			rjmp	Timer16			; TIMER0 OVF
			reti				; SPI, STC
			rjmp	RS232in			; UART, RX
			reti				; UART, UDRE
			reti				; UART, TX
			rjmp	AD			; ADC
			reti				; EE_RDY
			reti				; ANA_COMP

;**********************************************************************************************
; Alle moeglichen Daten
;**********************************************************************************************

version:		.db	"Jetcontrol 0.9 ",40,"18.10.2003",41," by Sven Stoecker"
			.db	" ",60,"sven.stoecker@epost.de",62,0

Sonderzeichen:		.db	0x02,0x05,0x02,0x00,0x00,0x00,0x00,0x00		;ein grd fuer Celsius
			.db     0x11,0x00,0x11,0x11,0x11,0x11,0x0e,0x00		;ein 
			.db	0x00,0x00,0x00,0x03,0x1F,0x03,0x00,0x00		;das 
			.db	0x00,0x00,0x07,0x1F,0x1F,0x1F,0x00,0x00		;ist
			.db	0x00,0x00,0x1C,0x1F,0x1F,0x1F,0x00,0x00		;doch 
			.db	0x00,0x00,0x00,0x1F,0x1F,0x1F,0x00,0x00		;zu 
			.db	0x00,0x00,0x03,0x1F,0x1F,0x1F,0x00,0x00		;erkennen
			.db	0x06,0x1E,0x3E,0x3F,0x3F,0x3C,0x00,0x00		;oder?
 
Text:       		.db	0x02,0x03,0x04,0x05,0x06,0x07," Jetcontrol Beta-Pr",0x01,"fstandversion V0.9 ",0x02,0x03,0x04,0x05,0x06,0x07," f",0x01,"r Einstellungen Men",0x01," dr",0x01,"cken ",0x02,0x03,0x04,0x05,0x06,0x07," "
			.db	"www.jetcontrol.de ",0x02,0x03,0x04,0x05,0x06,0x07," PC-Anbindung ",0x01,"ber RS232  38400,8,N,1 "
MenText:    		.db     0x02,0x03,0x04,0x05,0x06,0x07," Jetcontro"		; 16 Zeichen mehr wegen der Rechenvariante!
			.db	"01 Licht        "
			.db	"02 Rx  aus      "
			.db	"03 Rx leer      "
			.db	"04 Rx voll      "
			.db 	"05 rpm aus      "
			.db 	"06 rpm min      "
			.db 	"07 rpm max      "
			.db 	"08 rpm-Rampe    "
			.db 	"09 Pumpe Start  "
			.db 	"10 Pumpe min    "
			.db	"11 Pumpe max    "
			.db	"12 Pumpe-Rampe  "
			.db 	"13 Temp Start   "
			.db 	"14 Temp max     "
			.db 	"15 Tank        *"
			.db	"16 Verbrauch   *"
			.db	"17 Imp/Umdrehung"
			.db	"18 Gl",0x01,"hspannung "
			.db	"19 zur",0x01,"cksetzen "
			.db	"20 Test Treiber "
			.db	"esc  -    +  ret"

Lieferzustand:	.dw	0x0000			;
		.dw	0x0000			;Men1
		.dw	0x044c			;Men2	Rx aus
		.dw	0x04b0			;Men3	Rx leer
		.dw	0x07d0			;Men4	RX voll
		.dw	0x0019			;Men5	rpm aus
		.dw	0x0023			;Men6	rpm min
		.dw	0x007d			;Men7	rpm max
		.dw	0x0000			;Men8	rpm Rampe
		.dw	0x009a			;Men9  Pumpe Start
		.dw	0x00e6			;Men10	Pumpe min
		.dw	0x01f4			;Men11 Pumpe max
		.dw	0x0000			;Men12 Pumpe Rampe
		.dw	0x0032			;Men13	Temp Start
		.dw	0x0320			;Men14	Temp max
		.dw	0x0000			;Men15 Tank
		.dw	0x0000			;Men16 Verbrauch
		.dw	0x0002			;Men17 Imp/Umdrehung
		.dw	0x00c8			;Men18 Glhspannung
		
;**********************************************************************************************
; jetzt kommen die Interuptroutinen
;**********************************************************************************************

;**********************************************************************************************
;Int 0 Interuptroutine fr Drehzahlmessung
;**********************************************************************************************

Drehmessung:		in	Itemp,SREG		;SREG sichern
			push	Itemp
			sbrc	ECU_Status,Drehmess	; Drehzahlmessung schon aktiv?
			rjmp	Drehende
			
Drehstart:		clr	Itemp		
			out	TCCR0,Itemp		;Timer halt
			in	MesswertLO,TCNT0	;Timerwert zwischenspeichern 
			mov	MesswertHI,TimerHI	;Timerwert zwischenspeichern
			in	Itemp,TIFR
			sbrc	Itemp,1 		;Timerueberlauf ja
			inc	MesswertHI 		;dann MesswerttHi korrigieren
			ldi	Itemp,2	
			out	TCCR0,Itemp		;Timer an
			ori	ECU_Status,0b10000000		
			rjmp	Intex
			
Drehende:		clr	Itemp		
			out	TCCR0,Itemp		;Timer halt
			in	Itemp,TCNT0		;Timerwert zwischenspeichern 
			sub	Itemp,MesswertLO	;Differenz Werte LO
			sts	DrehLO,Itemp		;im SRAM sichern
			mov	Itemp,TimerHI		;TimerHI zwischenspeichern
			in	MesswertLO,TIFR
			sbrs	MesswertLO,1		; Timerueberlauf
			rjmp	Dreh1
			inc	Itemp			; dann korroigieren
Dreh1:			sbc	Itemp,MesswertHI	;Differenz Werte HI
			brbc	0,Dreh2			;Ergebnis  nicht negativ
			clr	MesswertHI		;korrigieren
			sub	MesswertHI,Itemp

Dreh2:			sts	DrehHI,Itemp		; Differenz sichern
			ldi	Itemp,2	
			out	TCCR0,Itemp		;Timer an	
			mov	Itemp,ECU_Status
			andi	Itemp,0b01111111	; Drehzahlmessflag loeschen
			ori	Itemp,0b01000000
			mov	ECU_Status,Itemp
			ldi	Itemp,0b11000000	;(int1) Servomessung an 	
			out 	GIMSK,Itemp		
			rjmp	Intex

;**********************************************************************************************
;Int 1 Interuptroutine fr Servoimpulsmessung		
;**********************************************************************************************
		
Servomessung:		in	Itemp,SREG		;SREG sichern
			push	Itemp
			in	Itemp,MCUCR 
			sbrc	Itemp,2			;0= noch keine Messung	
			rjmp	Servoende		;1= misst schon	

Servoanfang:		clr	Itemp		
			out	TCCR0,Itemp		;Timer halt
			in	ServomessLO,TCNT0	;Timerwert zwischenspeichern 
			mov	ServomessHI,TimerHI	;Timerwert zwischenspeichern
			in	Itemp,TIFR
			sbrc	Itemp,1 		;Timerueberlauf ja
			inc	ServomessHI 		;dann MesswerttHi korrigieren
			ldi	Itemp,2	
			out	TCCR0,Itemp		;Timer an
			ldi	Itemp,0b00001111	;Messung luft setzen (= Flanke umschalten)	
			out	MCUCR,Itemp		;und steigende Flanke Servo
			rjmp	Intex

Servoende:		clr	Itemp		
			out	TCCR0,Itemp		;Timer halt
			in	Itemp,TCNT0		;Timerwert zwischenspeichern 
			sub	Itemp,ServomessLO	;Differenz Werte LO
			sts	ServoLO,Itemp		;im SRAM sichern
			mov	Itemp,TimerHI		;TimerHI zwischenspeichern
			in	ServomessLO,TIFR
			sbrs	ServomessLO,1		; Timerueberlauf
			rjmp	Servo1
			inc	Itemp			; dann korroigieren
Servo1:			sbc	Itemp,ServomessHI	;Differenz Werte HI
			brbc	0,Servo2		;Ergebnis  nicht negativ
			clr	ServomessHI		;korrigieren
			sub	ServomessHI,Itemp

Servo2:			sts	ServoHI,Itemp		; Differenz sichern
			ldi	Itemp,2	
			out	TCCR0,Itemp		;Timer an	
			mov	Itemp,ECU_Status
			andi	Itemp,0b10111111	; IntFlag 0 loeschen
			ori	Itemp,0b00100000
			mov	ECU_Status,Itemp
			ldi	Itemp,0b11000000	;Drehzahlmessung (int0)		
			out 	GIMSK,Itemp
			ldi	Itemp,0b00001011	;kein laufende (Servo-)Messung setzen	
			out	MCUCR,Itemp		; warten auf falende Flanke
			
Intex:			pop	Itemp	
			out	SREG,Itemp
			reti				; interrupt finished

;**********************************************************************************************
;Interuptroutine bei Zhlerberlauf
;steuert die GluehPWM
;gibt Rechenzyklus frei
;gibt Messungsueberwachung frei
;**********************************************************************************************

Timer16:		in	Itemp,SREG		;SREG sichern
			push	Itemp				
			inc 	TimerHI				
			brbs	1,Timerueberlauf	;wenn 0 
			mov	Itemp,TimerHI			
			andi	Itemp,0b01111111	;TimerHI = 128
			brbc	1,Gluehtest		;nein
			cbi	PORTC,2			; ja, Glueh aus
			rjmp	Intex
			
Gluehtest:		lds	Itemp,Gluehwert		; Gluehstartwert holen
			mov	Itemp2,TimerHI		
			andi	Itemp2,0b01111111		
			cpse	Itemp,Itemp2		; Gluehstartwert erreicht
			rjmp	Intex			; nein
			sbi	PORTC,2			; ja, Glueh an
			rjmp	Intex
			
Timerueberlauf:		ori	ECU_Status,0b00000100	;Rechenprozess freigeben	
			cbi	PORTC,2
		
			inc	Messkontrollzaehler	; Zhler fuer anzeigegeschwindigkeit		
			ldi	Itemp,2				; bei 2
			cpse	Messkontrollzaehler,Itemp	; angekommen
			rjmp	Intex			        ; nein dann zurueck
			clr	Messkontrollzaehler	; ja, dann wieder 0
			ori	ECU_Status,0b00001000	;Rechenprozess freigeben	
			rjmp	Intex
			
;**********************************************************************************************
;Interuptroutine fr ber RS232 eingehende Zeichen
;**********************************************************************************************

RS232in:		reti				; interrupt finished

;**********************************************************************************************
; Interuptroutinen bei AD-WAndler fertig
; Messwerte uer Ackuspannung werden in AckuHI:AckuLO abgelegt
; Messwerte uer Temperatur   werden in TempHI:TempLO abgelegt
; Registerer Itemp,Itemp2
;**********************************************************************************************

AD:			in	Itemp,SREG		;SREG sichern
			push	Itemp
			in	Itemp,ADMUX
			sbrs	Itemp,0
			rjmp	Ackumess

Tempmess:		in	Itemp,ADCL		;Messwert LO
			sts	TempLO,Itemp		;im SRAM-Variable
			in	Itemp,ADCH		;Messwert HI		
			sts	TempHI,Itemp		;im SRAM-Variable
			ldi	Itemp,4			; AD4 an
			out	ADMUX,Itemp
			rjmp	Endmess		

Ackumess:		in	Itemp,ADCL		;Messwert LO
			ldi	Itemp2,72		
			add	Itemp,Itemp2		;Ofset der Sperrdiode von 0,7V addieren
			sts	AckuLO,Itemp		;im SRAM-Variable
			in	Itemp,ADCH		;Messwert HI		
			clr	Itemp2			
			adc	Itemp,Itemp2		;Uebertrag addieren
			sts	AckuHI,Itemp		;im SRAM-Variable
			ldi	Itemp,5			; AD5 an
			out	ADMUX,Itemp
Endmess:		ldi	Itemp,0b11001111	;Messung
			out	ADCSR,Itemp		;neu starten
			rjmp 	Intex			;und zurck

;**********************************************************************************************
; jetzt kommen Unterprogramme
;**********************************************************************************************

;**********************************************************************************************
;I2C_Bus_Steuerung
;Daten senden
;	rcall	I2C_Start			;Startet den Datenaustausch
;	rcall	I2C_Send			;0xA0 die Adresse des 24xxx fuer schreiben
;	rcall	I2C_Send			;HI-Byt Speicheradresse
;	rcall	I2C_Send			;LO-Byt Speicheradresse
;	rcall	I2C_Send			;Daten Byt 0
;	...					;....
;	rcall	I2C_Send			;Daten Byt 7 (maxial, auch weniger)
;	rcall	I2C_Stop			;Beendet Datenuebertragung und startet internen Schreibprozess fuer 5msec
;Daten empfangen
;	(evtl ueber Senden Adresse setzen)
;	rcall	I2C_Start			;Startet den Datenaustausch
;	rcall	I2C_Empfang			;Empfaengt ein Zeichen
;	rcall	I2C_Empfang_x			;Empfaengt das letzte Zeiche
;	rcall	I2C_Stop			;Beendet Datenuebertragung
;**********************************************************************************************

I2C_Start:		rcall	I2C_ini			; Datenleitungen richtig setzen
			rcall	SDA_L			; Startbedingung setzen
			rcall	I2C_Delay	 
			rjmp 	I2C_Delay		; Ruecksprung! ueber Delay
			
			
I2C_Send:		ldi temp,8			; Zaehler fuer 8 Durchlaeufe (fuer 8 bit:-)

I2C_Send_1:		rcall	SCL_L			; Takt L fuer Daten aendern
			rcall 	I2C_Delay
			sbrc 	I2C_data, 7		;springe wenn Bit 7 gleich 0
			rcall 	SDA_H			;SDA high
			sbrs 	I2C_data, 7		;springe wenn Bit 7 gleich 0
			rcall 	SDA_L			;SDA low
			rcall	I2C_Delay
			rcall	SCL_H			; Takt HI fuer Daten gueltig
			rcall	I2C_Delay	
			rcall	I2C_Delay
			lsl	I2C_data		; naechstes Bit
			dec 	temp			; Schleifenzaehler verringern
			brbc 1, I2C_Send_1   		; noch nicht 0 ? dann nochmal

I2C_Test_ACK:		rcall	SCL_L		
			rcall	I2C_Delay
			rcall	SDA_H			; Hier wird noch nichts getestet:-)
			rcall	I2C_Delay
			rcall	SCL_H		 
			rcall	I2C_Delay
			rjmp	I2C_Delay
			
I2C_Empfang:		ldi temp,8			; Zaehler fuer 8 Durchlaeufe (fuer 8 bit:-)
			
I2C_Empfang_1:		rcall	SCL_L			; Takt L 	
			rcall 	I2C_Delay
			rcall 	I2C_Delay
			rcall	SDA_H			; Daten auf Eingang
			rcall	SCL_H			; Takt H, daten jetzt gueltig
			rcall 	I2C_Delay	
			lsl 	I2C_data		; schiebe links 
			sbic 	PINB, 2			; springe wenn sda low
			inc 	I2C_data		; sonst incrementiere data
			rcall	I2C_Delay
			dec 	temp			; Schleifenzaehler verringern
			brbc 1, I2C_Empfang_1   	; noch nicht 0 ? dann nochmal

I2C_Send_ACK:		rcall	SCL_L		
			rcall	I2C_Delay
			rcall	SDA_L
			rcall	I2C_Delay
			rcall	SCL_H
			rcall	I2C_Delay
			rjmp	I2C_Delay

I2C_Empfang_x:		ldi temp,8
			
I2C_Empfang_2:		rcall	SCL_L			
			rcall 	I2C_Delay
			rcall 	I2C_Delay
			rcall	SDA_H
			rcall	SCL_H
			rcall 	I2C_Delay
			lsl 	I2C_data	
			sbic 	PINB, 2		
			inc 	I2C_data	
			rcall	I2C_Delay
			dec 	temp
			brbc 1, I2C_Empfang_2   

I2C_Send_No_ACK:	rcall	SCL_L
			rcall	I2C_Delay
			rcall	SDA_H
			rcall	I2C_Delay
			rcall	SCL_H
			rcall	I2C_Delay
			rjmp	I2C_Delay
			
I2C_Stop:		rcall	SCL_L
			rcall	SDA_L
			rcall	I2C_Delay
			rcall	I2C_Delay
			rcall	SCL_H
			rcall	I2C_Delay
			rcall	SDA_H
			rjmp	I2C_Delay
			
SDA_L:			cbi PORTB,2			;lsche Ausgangspin
  			sbi DDRB, 2			;make SDA pin an output
  			ret
  			
SDA_H:			cbi PORTB,2			;setze Tri-state
  			cbi DDRB, 2			;make SDA pin an input
  			ret
  				
SCL_L:			cbi PORTB, 0			;lsche Ausgangspin
  			sbi DDRB, 0			;make SCL pin an output
  			ret
  			
SCL_H:			cbi PORTB, 0			;setze Tri-state
	  		cbi DDRB, 0			;make SCL pin an output
I2C_Ret:		ret
  			
I2C_ini:		in	temp,DDRB
			ori	temp,0b00000101		; I2C Pin auf Ausgang setzen
			out	DDRB,temp			 
			rcall	SCL_H
			rcall	SDA_H

;**********************************************************************************************
;Warteschleife fuer I2C
;wird je Takt 4x aufgerufen,
;max 100kHz=80Schritte/4=20Schritte je Delay= 5
;**********************************************************************************************

I2C_Delay:		ldi	temp2,5
I2C_Delay_1:		dec	temp2
			brbs	1,I2C_Ret
			rjmp	I2C_Delay_1

;**********************************************************************************************
; SendCommand sendet ein Commando an das LCD-Display
; SendText    sendet ein Zeichen  an das LCD-Display
;**********************************************************************************************

SendCommand:		cbi	PORTB,RS		; clear RS = Commando
			rjmp	Send

SendText:		sbi	PORTB,RS		; set RS = Zeichen
Send:			mov	temp,sendbuf		; get sendebyte into temp
			andi	temp,$F0		; clear lower 4 bit
			in	temp2,PORTD		; get current PORTD
			andi	temp2,$0F		; clear upper 4 bits
			or	temp2,temp		; set new upper 4 bits
			out	PORTD,temp2		; output the new value
			cbi	PORTB,ENABLE
			sbi	PORTB,ENABLE		; toggle send
			mov	temp,sendbuf		; get sendebyte
			swap	temp			; swap nibbles
			andi	temp,$F0		; clear lower 4 bits
			andi	temp2,$0F		; clear upper 4 bit of output
			or	temp2,temp		; set new 4 bits
			out	PORTD,temp2		; output
			cbi	PORTB,ENABLE
			sbi	PORTB,ENABLE		; toggle send
			rcall	Delay50			; Warten, da kein Polling auf fertig
			ret

;**********************************************************************************************
;Warteschleifen fr die Displayansteuerung
;   1 cycle = 125ns;
;   100sec =    800 c
;  4100sec =  32800 c
; 15000sec = 120000 c
;**********************************************************************************************

Delay50:		nop				; 1 cycle 	; total 400 = (77*5)+(1*2)+10+3
			nop				; 1 cycle
			nop				; 1 cycle
			ldi	temp2,77		; 1 cycle
			ldi	temp3,1			; 1 cycle
			rjmp	Delay			; 2 cycles

Delay100:		nop				; 1 cycle 	; total 800 = (157*5)+(1*2)+10+3
			nop				; 1 cycle
			nop				; 1 cycle
			ldi	temp2,157		; 1 cycle
			ldi	temp3,1			; 1 cycle
			rjmp	Delay			; 2 cycles

Delay4100:		nop				; 1 cycle	; total 32800 = (6547*5)+(26*2)+10+3
			nop				; 1 cycle
			nop				; 1 cycle
			ldi	temp2,147		; 1 cycle
			ldi	temp3,26		; 1 cycle
			rjmp	Delay			; 2 cycles

Delay15000:		nop				; 1 cycle	; total 120000 = (23808*5)+(94*2)+10+2
			nop				; 1 cycle
			ldi	temp2,152		; 1 cycle
			ldi	temp3,94		; 1 cycle
			rjmp	Delay			; 2 cycles

;**********************************************************************************************
; RCALL needs 3 cycles
; each inner loop = 5
; each outer loop = +2  (3-1)
; last loop       = +3  (4-1)
; formula == ((temp2+(temp3-1)*256)*5)+(temp3*2)+10+(num of nops)
;**********************************************************************************************

Delay:			nop				; 1 cycle
			nop				; 1 cycle
			dec	temp2			; 1 cycle
			brne	Delay			; 2/1 cycles	; Check if inner loop is finished
			dec 	temp3			; 1 cycle
			brne 	Delay			; 2/1 cycles	; Check if outer loop is finished
			ret				; 4 cycles		
	
;**********************************************************************************************
;Errechen der 1000er Stelle bei Derimalausgabe
;Wert 0-9999 in ZL,ZH uebergeben.
;fuer Nullausblendung in Sendbuf ein Leerzeichen uebergeben
;Ausgabewert in sendbuf
;genutzte Register: YL,YH,SREG,temp
;**********************************************************************************************

LCD1000er:		ldi	YL,0xe8			;Divisor 
			ldi	YH,0x03			;1000
			ldi	temp,0x2f		;1.Stelle Start ASCII 0 minus 1	
LCDjump1001:		inc	temp			;Ergebnis um 1 wehoehen
			sub	ZL,YL			;rechen wert minus 1000
			sbc	ZH,YH
			brcc	LCDjump1001		;nochmal wenn noch kein uebertrag
			add	ZL,YL			;wenn Uebertrag wert wider berichtigen
			adc	ZH,YH
			subi 	temp,0x10		;wenn Ergebnis "0"-0x10 	
			cpse	temp,sendbuf		;=" "
			rjmp 	LCDjump1002		;nei
			ret				; nein
			ldi	sendbuf,0x20		; ja, " " ausgebern
			ret	
LCDjump1002:		subi temp,-0x10			;Ergebnis wiederherstellen
			mov  sendbuf,temp		;nach sendbuffer laden 
			ret

;**********************************************************************************************
;Errechen der 100er Stelle bei Derimalausgabe
;Wert 0-999 in ZL,ZH uebergeben.
;fuer Nullausblendung in Sendbuf ein Leerzeichen uebergeben
;Ausgabewert in sendbuf
;genutzte Register: YL,YH,SREG,temp
;**********************************************************************************************

LCD100er:		ldi	YL,100			;Divisor (X)
			ldi	YH,0			;100
			ldi	temp,0x2f		;1.Stelle Start ASCII 0 minus 1
LCDjump1:		inc	temp			;Ergebnis um 1 erhoehen
			sub	ZL,YL			;Rechenwert minus 100 
			sbc	ZH,YH			;
			brcc	LCDjump1		;nochmal wenn kein Ueberlauf
			subi	ZL,-100			; wenn ueberlauf Rechenwert(Z) berichtigen
			subi 	temp,0x10		;wenn Ergebnis "0"-0x10 	
			cpse	temp,sendbuf		;=" "
			rjmp 	LCDjump2		;nei
			ret				;ja dann zurueck
LCDjump2:		subi temp,-0x10			;Ergebnis wiederherstellen
			mov  sendbuf,temp		;nach sendbuffer laden 
			ret

;**********************************************************************************************
;Errechen der 10er Stelle bei Derimalausgabe
;Wert 0-99 in ZL uebergeben. 
;fuer Nullausblendung in Sendbuf ein Leerzeichen uebergeben
;genutzte Register: XL,SREG,temp
;Ausgabewert in sendbuf
;**********************************************************************************************

LCD10er:		ldi	temp,0x2f		;2. Stelle
LCDjump3:		inc	temp
			subi	ZL,10			;10
			brcc	LCDjump3
			subi	ZL,-10			;zuweit? +10
			subi temp,0x10			;Ergebnis "0"-0x10
			cpse	temp,sendbuf		;gleich " " aus vorhergenenden Zeichen
			rjmp LCDjump4			; nein
			ret				; ja dann zurueck
LCDjump4:		subi temp,-0x10			; Ergebnis wiederherstellen
			mov  sendbuf,temp		; nach sendbuf laden
			ret


;**********************************************************************************************
;Errechen der 1er Stelle bei Dezimalausgabe
;Wert 0-9 in ZL uebergeben. 
;Ausgabewert in sendbuf
;genutzte Register: SREG
;**********************************************************************************************

LCD1er:			mov	sendbuf,ZL		;3. Stelle			
			ori	sendbuf,0x30		; in ASCII-Zahl wandeln
			ret

;**********************************************************************************************
;Anzeige der Drehzahl
;Drehzahl in ZH:ZL uebergeben
;* Parameter : 	  keine
;* Ruckgabewerte: keine
;**********************************************************************************************

Anzeigedrehzahl:	ldi	sendbuf,' '		;Nullausblendung erzeugen
			rcall	LCD1000er		;1000er 
			rcall	LCD100er		;100er 
			rcall	SendText		;ausgeben
			rcall	LCD10er			;10er 
			rcall	SendText		;ausgeben
			rcall	LCD1er			;1er 
			rcall	SendText		;ausgeben
           		ldi	sendbuf,'o'		
			rcall	SendText
           		ldi	sendbuf,'o'		
			rcall	SendText
           		ldi	sendbuf,'o'		
			rjmp	SendText

;**********************************************************************************************
;* Anzeige der einer Zeit in ms 
;* Periode in ZH:ZL uebergeben; 0,001ms Schritte
;* Parameter : 	  keine
;* Ruckgabewerte: keine
;**********************************************************************************************

Anzeigems:		ldi	sendbuf,'x'		;Nullausblendung abschalten
			rcall	LCD1000er		;1000er 
			rcall	SendText
           		ldi	sendbuf,'.'		
			rcall	SendText
           		rcall	LCD100er		;100er 
			rcall	SendText		;ausgeben
			rcall	LCD10er			;10er 
			rcall	SendText		;ausgeben
			rcall	LCD1er			;1er 
			rcall	SendText		;ausgeben
           		ldi	sendbuf,' '		
			rcall	SendText
           		ldi	sendbuf,'m'		
			rcall	SendText
           		ldi	sendbuf,'s'		
			rjmp	SendText

;*********************************************************************************************
;* Anzeige einer Temperatur
;* Temperatur  1 Schritt/1 grd C in ZH:ZL uebergeben
;* Parameter : 	  keine
;* Ruckgabewerte: keine
;*********************************************************************************************

AnzeigeTemp:		ldi	sendbuf,' '		;Vornullausblendung ein
			rcall	LCD1000er		;100er
			rcall	SendText		;anzeigen
			rcall	LCD100er		;100er
			rcall	SendText		;anzeigen
			rcall	LCD10er			;10er 
			rcall	SendText		;Anzeigen
			rcall	LCD1er			;1er 
			rcall	SendText		;anzeigen
			ldi	sendbuf,0		;Sonderzeichen 0	
			rcall	SendText		;anzeigen
			ldi	sendbuf,'C'		;"C" (grd)
			rjmp	SendText

;*********************************************************************************************
;* Anzeige einer Spannung
;* Spannung 1024 Schritte/10V in ZH:ZL uebergeben
;* Parameter : 	  keine
;* Ruckgabewerte: keine
;*********************************************************************************************

AnzeigeSpannung:	lsl	ZL 
			rol	ZH			;*64
			lsl	ZL			;=6xlinks					
			rol	ZH			;um 16bit voll auszunutzen
			lsl	ZL 
			rol	ZH
			lsl	ZL			
			rol	ZH
			lsl	ZL 
			rol	ZH
			ldi	temp3,0xff		;Zaehlvariable Startwert
			ldi	XL,60			;Divisor 
			ldi	XH,1			
rech1:			inc	temp3			;Ausgabewert berechnen	
			sub	ZL,XL			;in 0,1V Schritten
			sbc	ZH,XH			;ZL und ZH vertauscht
			brcc	rech1		
			mov	ZL,temp3
			clr	ZH
			ldi	Sendbuf,' '
			rcall	LCD1000er
			rcall	LCD100er
			rcall	SendText	
			ldi	sendbuf,'x'		;Komma senden
			rcall	LCD10er
			rcall	SendText	
			ldi	sendbuf,'.'		;Komma senden
			rcall	SendText
			rcall	LCD1er
			rcall	SendText
			ldi	sendbuf,' '		
			rcall	SendText
			ldi	sendbuf,'V'
			rjmp	SendText

;**********************************************************************************************
;Abfrage der 4 Taster. 
;Ergebnis auf Taster im S-Ram abgelegt. 
;aenderungen    in bit 0-3	1=geaendert, 0=ungeaendert 
;Tasterstellung in bit 4-7	1=gedrueckt, 0=ungedrueckt
;genutzte Register: temp,temp2 
;**********************************************************************************************

Tasterin:		in	temp,DDRD		; Port D
			andi 	temp,0b00001111		; 4-7 als Eingang
			out	DDRD,temp   		; setzen			
			in	temp,PORTD		; Port D
			andi 	temp,0b00000010		; TRI-State
			out	PORTD,temp   		; setzen			
			in	temp,DDRC		; Port C
			ori	temp, 0b00001111	; 0-3 als Ausgang
			out	DDRC,temp		; setzen
			cbi	PORTC,3			; Taster aktivieren
			in	temp,PIND		; Port laden
			ldi	temp2,0xf0		
			eor	temp,temp2		; Tasterbits umkehren jetzt 1 = aktiv
			lds	temp2,Taster		; alte Tasterstellung laden
			eor	temp2,temp		; Aenderunger feststellen 
			andi	temp2,0xf0		; im beren Nibble
			andi	temp,0xf0		; Tasterstellung neu
			swap	temp2			; ins untere Nibble
			add	temp,temp2		; laden
			sts	Taster,temp		; im SRAM ablegen
			in	temp,DDRC		; Port C
			andi 	temp,0b00000111		; 3-7 als Eingang
			out	DDRC,temp		; setzen
			in	temp,DDRD		; Port D
			ori 	temp,0b11110000		;4-7 als Ausgang
			out	DDRD,temp   		; setzen
			ret

;**********************************************************************************************
;Ausgabe von Zeichen ueber RS232
;**********************************************************************************************

RS232send:		in	temp,UCSRA		;UART Status laden
			sbrs 	temp,5			;test auf Senden fertig
			rjmp	RS232send		;nein dann warten
			out	UDR,sendbuf		;senden
			ret

;**********************************************************************************************
;Ueberwachung der Servomessung und Drehzahlmessung
;**********************************************************************************************

Messcontrolle:		cli
			mov	temp,ECU_Status
			andi	temp,0b11110111		; Ventilflag loeschen
			mov	ECU_Status,temp
			sei

;Ueberwachung der Servomessung
			
Drehtest:		sbrc	ECU_Status,DrehiO
			rjmp	Servotest	
	
AbbrDreh:		ldi	Itemp,0xff				
			sts	DrehLO,Itemp		;Drehzahl loeschen = Messwert 0xFFFF
			sts	DrehHI,Itemp
				
;Ueberwachung der Drehzahlmessung			
			
Servotest:		sbrc	ECU_Status,ServoiO
			rjmp	Messflagloesch	

AbbrServo:		clr	Itemp
			sts	ServoLO,Itemp		;Servo	zurcksetzen auf min
			sts	ServoHI,Itemp
				
Messflagloesch:		cli	
			mov	temp,ECU_Status
			andi	temp,0b10010111		; Ventilflag loeschen
			mov	ECU_Status,temp
			sei
			ret

;*********************************************************************************************
;* Anzeige einer Laufschrift
;*********************************************************************************************

Laufschrift:		inc	textV			; Zhler fuer Anzeigegeschwindigkeit		
			ldi	temp,5			; bei 150
			cpse	textV,temp		; angekommen
			ret			        ; nein dann zurueck

			clr	textV			; ja, dann wieder 0
			ldi 	sendbuf,LINE3		; Display  Zeile 3 	
    			rcall	SendCommand		; setzen
     			clr	temp			; loeschen fuer addition
     	     		ldi    	ZL,low(Text*2)		; setze Lauftextanfang	
             		ldi    	ZH,high(Text*2)	
      	     		mov	temp2,textpos		; Lade die Textposition
            		add	ZL,temp2		; addiere zu Lauftextanfang	
             		adc	ZH,temp			; wenn Ueberlauf dann H+1
             		inc	temp2			; naechste Textposition
             		ldi	temp,152		; 238 = Lauftextende
             		cpse	temp2,temp		; erreicht?
             		rjmp 	Laufschrift1		; neun, dann Textanzeige
             		clr	temp2			; Ja, dann ruecksetzen
Laufschrift1:	     	mov	textpos,temp2		; Textposition abspeichern
	     
			ldi    	XL,16			; 16 Zeichen je Zeile
Laufschrift2:  		lpm 				; Zeiche laden nach R0
             		mov	sendbuf,R0		; kopieren in Sendepuffer
             		rcall   SendText		; und anzeigen
             		adiw	ZH:ZL,1			; naechstes Zeichen setzen
     			dec   	XL			; Zaehler /Zeile verringern
             		brbc   	1,Laufschrift2 		; schon Null,nein -> nochmal
			ret		

;*********************************************************************************************
;* Anzeige einer Zeit	hh:mm:ss
;* Zeit in sec in ZH:ZL uebergeben			
;*********************************************************************************************

LCD_Time:		ldi	XL,16			;Divisor 
			ldi	XH,14			;3600 sek = h
			ldi	YL,0xff			;1.Stelle Start 0 minus 1	
LCD_Time1:		inc	YL			;Ergebnis um 1 wehoehen
			sub	ZL,XL			;rechen wert minus 1000
			sbc	ZH,XH
			brcc	LCD_Time1		;nochmal wenn noch kein uebertrag
			add	ZL,XL			;wenn Uebertrag wert wider berichtigen
			adc	ZH,XH
			ldi	sendbuf,0x2f		;1.Stelle Start ASCII 0 minus 1	
LCD_Time2:		inc	sendbuf			;Ergebnis um 1 wehoehen
			subi	YL,10			;rechen wert minus 10
			brcc	LCD_Time2		;nochmal wenn noch kein uebertrag
			subi	YL,-10			;wenn Uebertrag wert wider berichtigen
			cpi 	sendbuf,0x30		; ist ergebnis "0"
			brbc	1,LCD_Time3		; nein
			ldi	sendbuf,0x20		; ja, " " ausgebern
LCD_Time3:		rcall	SendText
			mov	Sendbuf,YL		
			subi	Sendbuf,-0x30
			rcall	SendText	
			ldi	Sendbuf,':'		
			rcall	SendText	
			
			ldi	XL,60			;Divisor 
			ldi	XH,0			;60 sek = min
			ldi	YL,0xff			;1.Stelle Start 0 minus 1	
LCD_Time4:		inc	YL			;Ergebnis um 1 wehoehen
			sub	ZL,XL			;rechen wert minus 1000
			sbc	ZH,XH
			brcc	LCD_Time4		;nochmal wenn noch kein uebertrag
			add	ZL,XL			;wenn Uebertrag wert wider berichtigen
			adc	ZH,XH
			ldi	sendbuf,0x2f		;1.Stelle Start ASCII 0 minus 1	
LCD_Time5:		inc	sendbuf			;Ergebnis um 1 wehoehen
			subi	YL,10			;rechen wert minus 10
			brcc	LCD_Time5		;nochmal wenn noch kein uebertrag
			subi	YL,-10			;wenn Uebertrag wert wider berichtigen
			rcall	SendText
			mov	Sendbuf,YL		
			subi	Sendbuf,-0x30
			rcall	SendText	
			ldi	Sendbuf,':'		
			rcall	SendText	
			rcall	LCD10er
			rcall	SendText	
			rcall	LCD1er
			rjmp	SendText

;*********************************************************************************************
;* Anzeige einer Textzeile von 16Zeichen
;* Zeile in temp uebergeben			
;*********************************************************************************************

Textzeile:   		ldi    	ZL,low(MenText*2)	;Zeiger auf Text laden
             		ldi    	ZH,high(MenText*2)
			inc	temp			;um 1 erhoehen da gleich 
Textzeile1:		dec	temp			;um 1 verringern
			brbs	1,Textzeile2		;schon Null?
			adiw	ZH:ZL,16		;16 Zeichen weiter= naechste Zeile
			rjmp	Textzeile1		;nochmal
Textzeile2:    		ldi    	XL,16			;Zeichenzaehler je Zeile
Textzeile3:		lpm 				;Zeichen nach R0
     			mov	sendbuf,R0		;Zeichen in den Sendbuffer
   			rcall   SendText		;Senden
       			adiw	ZH:ZL,1			;Zeigen auf naechstes Zeichen
     			dec   	XL			;Zeichenzaehler verringern
       			brbc   	1,Textzeile3 		;= 0,schon das letzte zeichen
			ret	

;*********************************************************************************************
;Werte  fuer Men aus dem EEPRom holen
;Uebergabewere keine
;Ruckgabe des Parameterwertes in Z
;*********************************************************************************************

HoleEEWert:		lds	temp,Menzeile

;**********************************************************************************************
;Holt Parameter aus dem EEPRom anch Z 
;Parameter entsprechend liste in temp uebergeben
;Ruckgabe des Parameterwertes in Z
;**********************************************************************************************
						
HoleParameter:		lsl	temp
			out	EEAR,temp
			sbi	EECR,EERE
			in	ZL,EEDR
			inc	temp
			out	EEAR,temp
			sbi	EECR,EERE
			in	ZH,EEDR
			ret

;*********************************************************************************************
; Werte  aus dem Men im EEPRom speichern
; zu Speichernder Wert in Z uebergeben
;*********************************************************************************************
			
SendEEWert:		lds	temp,Menzeile
			
;*********************************************************************************************
; Werte im EEPRom speichern
; Position in temp uebergeben
; zu Speichernder Wert in Z uebergeben
;*********************************************************************************************
			
			sbic	EECR,EEWE
			rjmp	SendEEWert
			cli
			lsl	temp
			out	EEAR,temp
			out	EEDR,ZL
			sbi	EECR,EEMWE
			sbi	EECR,EEWE
			sei
SendEEWert1:		sbic	EECR,EEWE
			rjmp	SendEEWert1
			cli
			inc	temp
			out	EEAR,temp
			out	EEDR,ZH
			sbi	EECR,EEMWE
			sbi	EECR,EEWE
			sei
			ret

;**********************************************************************************************
;Setzen der PWM fuer Gluehkerze 
;Register x,y,z, temp,temp2
;**********************************************************************************************

Gluehrech:		ldi	temp,18
			rcall	HoleParameter		;aus EEProm nach Z
			rcall	PWM_Berech
			lsr	temp
			ldi	temp2,128
			sub	temp2,temp
			sts	Gluehwert,temp2
			ret

;**********************************************************************************************
;Berechnet 8 bit PWM 
;Ausgangangsspannungin ZH:ZL uebergeben
;Ruckgabewert PWM in temp
;Register x,y,z, temp,temp2
;**********************************************************************************************
			
PWM_Berech:		lsr	ZH
			ror	ZL
			lsr	ZH
			ror	ZL			;jertz Acku und PWM 8bit
			
;PWM+PWM*256		
			mov	YL,ZL
			clr	YH
			clr	ZH
			clr	temp		
PWM_Berech2:		subi	ZL,1			
			brbs	0,PWM_Berech3
			add	ZH,YL
			adc	temp,YH
			rjmp	PWM_Berech2
						
PWM_Berech3:		clr	ZL
			cli
			lds	XL,AckuLO		;Ackuspannung
			lds	XH,AckuHI		;nach Z laden
			sei
			lsr	XH			;2xrechts					
			ror	XL			
			lsr	XH 
			ror	XL			;=8bit
			mov	XH,XL

;XH:XL*XH:XL	
			clr	temp2
			clr	YL
			clr	YH
PWM_Berech4:		subi	XH,1
			brbs	0,PWM_Berech5			
			add	YL,XL
			adc	YH,temp2
			rjmp	PWM_Berech4
			
;temp:ZH:ZL durch XH:XL

PWM_Berech5:		ldi	XH,0xff
			ldi	XL,0xff
PWM_Berech6:		adiw    XH:XL,1
			sub	ZL,YL			
			sbc	ZH,YH
			sbc	temp,temp2
			brbc	0,PWM_Berech6
			mov	temp,XL
			ret
						
;**********************************************************************************************
; Ab hier gehts richtig los:-)
; das ist der Programmstart nach Reset und Power on
;**********************************************************************************************

;**********************************************************************************************
; Initialisieren der Ports
;**********************************************************************************************

Start:			ldi	temp,RAMEND		
			out	SPL,temp		; set stack pointer
			ldi	temp,0b11110000
			out	DDRD,temp		; set port D (4-7) as output
			ldi	temp,0b00000111
			out	DDRC,temp		; set port c (0-2) as output
			out	PORTC,temp
			sbi	PORTB,ENABLE		; clear enable
			sbi	PORTB,LIGHT		; Light off
			sbi	PORTB,RS		; clear RS
			ldi	temp,0b00111111
			out	DDRB,temp		; set port B (0-5) as output
			sbi	PORTB,ENABLE		; clear enable
			sbi	PORTB,RS		; clear RS
			cbi	PORTC,0			; Starter aus
			cbi	PORTC,1			; Gas aus
			cbi	PORTC,2			; Glueh aus
			sbi	PORTC,3			; Taster deaktivuert
			sbi	PORTB,3			; Licht aus
			sbi	PORTB,0			; SLC Hi
			sbi	PORTB,2			; SDA Hi

;**********************************************************************************************
; Initialisieren der Variablen
;**********************************************************************************************

			clr	Messkontrollzaehler
			clr	r24			;Systemzeit zuruecksetzen
			clr	r25			;Systemzeit zuruecksetzen
			clr	ECU_Status
			clr 	textpos	
			clr 	textV
			sts	Zeitzaehler,textV
			sts	Gluehwert,textV
			sts	Menzeile,textV		; Men zuruecksetzen
			
;**********************************************************************************************
; Initialisierung der PWM
;**********************************************************************************************
			
			clr	temp		
			out	OCR1L,temp		; lschen PWM 
			ldi	temp,0x81		; 8bit-PWM normal
			out	TCCR1A,temp
			ldi	temp,2			; PWM an mit CK/8
			out	TCCR1B,temp		

;**********************************************************************************************
; Initialisierung des Displays
;**********************************************************************************************

			rcall	Delay15000			; wait 15ms for LCD get powered up
			ldi	sendbuf,FUNCTIONSET + SET_4BIT 	;+ SET_2LINE + SET_5X8
			cbi	PORTB,RS			; clear RS
			mov	temp,sendbuf		; get sendebyte into temp
			andi	temp,$F0		; clear lower 4 bit
			in	temp2,PORTD		; get current PORTD
			andi	temp2,$0F		; clear upper 4 bits
			or	temp2,temp		; set new upper 4 bits
			out	PORTD,temp2		; output the new value
			cbi	PORTB,ENABLE		; set enable
			sbi	PORTB,ENABLE		; clear enable
			rcall	Delay50
			ldi	sendbuf,DISPLAYMODE + DMODE_DISPON 	;+ DMODE_CURSON + DMODE_BLINK
			rcall	SendCommand
			
;**********************************************************************************************
; Senden der Sonderzeichen zum LCD
;**********************************************************************************************

			ldi	sendbuf,Zeichenram	;LCD_ZEICHEN_Ram setzen			
 			rcall	SendCommand
     	     		ldi    	ZL,low(Sonderzeichen*2)	; setze Lauftextanfang	
             		ldi    	ZH,high(Sonderzeichen*2)	
		     	ldi    	XL,64			; 64 byt fuer eigene Sonderzeichen
Sonder:    		lpm 				; Zeiche laden nach R0
             		mov	sendbuf,R0		; kopieren in Sendepuffer
             		rcall   SendText		; und anzeigen
             		adiw	ZH:ZL,1			; naechstes Zeichen setzen
	     		dec   	XL			; Zaehler /Zeile verringern
             		brbc   	1,Sonder 		; schon Null,nein -> nochmal

;**********************************************************************************************
; Initialisierung RS232
;**********************************************************************************************

			sbi	UCSRB,RXCIE		; enable RX interrupt
			sbi	UCSRB,TXEN		; enable serial sending
			sbi	UCSRB,RXEN		; enable serial receiving
			ldi	temp,12
			out	UBRR,temp		; 38400 baud rate setting

;**********************************************************************************************
; Initialisierung des AD-Wandlers
;**********************************************************************************************

			ldi	temp,4			; AD4 an
			out	ADMUX,temp
			ldi	temp,0b11001111
			out	ADCSR,temp	

;**********************************************************************************************
; Initialisierung des Timers
;**********************************************************************************************

			in	temp,TIMSK		;Timerberlauf freigeben
			ori	temp,0b00000010
			out	TIMSK,temp
			ldi	Itemp,2			;Starten des Timers
			out	TCCR0,Itemp		;Taktquelle 1/8 ein

;**********************************************************************************************
; Initialisierung der Servomessung und Drehzahlmessung
;**********************************************************************************************
		
			ldi	temp,0b00001011		;Int1 fallende Flanke	
			out 	MCUCR,temp		;Int0 steigende Flanke
			ldi	temp,0b11000000		;Int0 u. 1 feigeben 	
			out 	GIMSK,temp
			ldi	temp,0xff		;verhindert Diff durch 0 bei Drehzahlanzeige vor Messung
			sts	DrehHI,temp
			sts	AckuLO,temp
			sts	AckuHI,temp
			ldi	temp,13			; 1sec
			out	wdtcr,temp		;Watchdog aktivieren

;**********************************************************************************************
; Alles erledigt?
; Dann geht jetzt die richtige Arbeit los
;**********************************************************************************************
					
			sei				; enable global interrupts

;**********************************************************************************************
; Endlosschleife fuer Timingsteuerung
; Die einzelnen Prozesse werden durch die Flags im ECU_Status freigegenden
; Der ECU_Status wird durch den Timerinterupt gesetzt und in den Prozessen zurueckgesetzt
; Prozesse mit hoeherer Prioritaet oben   
;**********************************************************************************************

loop:			;cbi	PORTC,1			; Debug : Anzeige der Rechenzeit ueber Starter
			sbrc	ECU_Status,Rechen	; Rechenzyklus freigegeben?
			rcall	Anzeige			; dann rechen
			
			sbrc	ECU_Status,Messtest	; Messueberwachung freigegeben?
			rcall	Messcontrolle		; dann ueberwachen
						
			rjmp	loop

;**********************************************************************************************
;Anzeige der Daten auf dem Display
;**********************************************************************************************
		
Anzeige:		cli
			mov	temp,ECU_Status
			andi	temp,0b11111011		; Rechenflag loeschen
			mov	ECU_Status,temp
			sei
			wdr				;watchdog zuruecksetzen
			;sbi	PORTC,1			;Debug: Rechenzeittest ueber Starter
			
;**********************************************************************************************
; Berechen der Systemzeit in r24:r25, muss aller 15,30,45,61 Durchlaeufe incrementiert werden
;**********************************************************************************************

Sekundenzaehler:	lds	temp,Zeitzaehler
			inc	temp			; Zhler fuer anzeigegeschwindigkeit		
			cpi	temp,0x0f		; angekommen
			brbs	1,Sekunde		; nein dann zurueck
			cpi	temp,0x1e		; angekommen
			brbs	1,Sekunde		; nein dann zurueck
			cpi	temp,0x2d		; angekommen
			brbs	1,Sekunde		; nein dann zurueck
			cpi	temp,0x3d		; angekommen
			brbc	1,Sekunde1		; nein dann zurueck
			clr	temp
Sekunde:		adiw 	r25:r24,1                             
Sekunde1:		sts	Zeitzaehler,temp	; ja, dann wieder 0

;**********************************************************************************************
;Anzeige der Systemzeit in Sekunden
;**********************************************************************************************

Zeitanzeige:		ldi	sendbuf,LINE4+8	
			rcall	SendCommand	
			mov	ZL,r24			;Zeitzaehler laden
			mov	ZH,r25			;Zeitzaehler laden
			rcall	LCD_Time
			
;**********************************************************************************************
;Anzeige der Ackuspannung
;**********************************************************************************************

			ldi	sendbuf,LINE2+10	
			rcall	SendCommand	
			lds	ZL,AckuLO		;Ackuspannung
			lds	ZH,AckuHI		;nach Z laden
			rcall	AnzeigeSpannung

;**********************************************************************************************
;Anzeige der Temperatur
;**********************************************************************************************

Temp:			ldi	sendbuf,LINE1+10	;Zeile 2, 12 zeichen 
			rcall	SendCommand		;setzen
			cli				;Interupt sperren
			lds	ZL,TempLO		;Temperatur
			lds	ZH,TempHI		;nach Z laden
			sei				;Interupt freigeben
			rcall	AnzeigeTemp

;**********************************************************************************************
;Anzeige der Drehzahl
;**********************************************************************************************

			ldi	sendbuf,LINE1	
			rcall	SendCommand	
			ldi	YL,0xff
			ldi	YH,0xff
			lds	ZL,DrehLO
			lds	ZH,DrehHI
			ldi	XL,20;96		; 30000 = Periode bei "1"
			ldi	XH,234					; 
Drehrech:		adiw	YH:YL,1			; Drehzahl berechnen	
			sub	XL,ZL	
			sbc	XH,ZH
			brcc	Drehrech		
			
			ldi	temp,34
			out	EEAR,temp
			sbi	EECR,EERE
			in	XL,EEDR
			clr	XH
			ldi	ZL,0xff
			ldi	ZH,0xff
Drehrech1:		adiw	Zh:ZL,1
			sub	YL,XL	
			sbc	YH,XH
			brcc	Drehrech1		
			sts	DrehzahlLO,ZL
			sts	DrehzahlHI,ZH
			rcall	Anzeigedrehzahl
			ldi	Sendbuf,' '		
			rcall	SendText	
			ldi	Sendbuf,'r'		
			rcall	SendText	
			ldi	Sendbuf,'p'		
			rcall	SendText	
			ldi	Sendbuf,'m'		
			rcall	SendText	
			
;**********************************************************************************************
;Anzeige der Servostellung
;**********************************************************************************************
		
Servostellung:		ldi	sendbuf,LINE2+1	
			rcall	SendCommand	
			lds	XL,ServoLO		;Servostellung
			lds	XH,ServoHI		;nach X laden
			ldi	temp,2			;RXaus
			rcall	HoleParameter		;aus EEProm nach Z
			sub	ZL,XL			;
			sbc	ZH,XH			;
			set
			brbs	0,T_min			
			clt				
			clr	XL			;Loeschen der Servostellung
			clr	XH
			rjmp	SA			;Anzeige der Servostellung

T_min:			ldi	temp,3			;RXmin
			rcall	HoleParameter		;aus EEProm nach Z
			sub	ZL,XL			;
			sbc	ZH,XH			;
			brbs	0,T_max			;wenn RX > (3) in X	
			add	XL,ZL			;
			adc	XH,ZH			;
			rjmp	SA			;jetzt RX =(3) in X
						
T_max:			ldi	temp,4			;RXmax
			rcall	HoleParameter		;aus EEProm nach Z
			sub	ZL,XL			;
			sbc	ZH,XH			;
			brbc	0,SA			;wenn RX < (4)	
			add	XL,ZL			;
			adc	XH,ZH			;jetzt RX =(4)
SA:			mov	ZL,XL
			mov	ZH,XH
			bld	ECU_Status,1
			rcall	Anzeigems

;**********************************************************************************************
;Berechnen der Servostellung in 256 Schritten 0-255)
;**********************************************************************************************
			
			clr	temp
			sbrs	ECU_Status,1		;Pumpe an?
			rjmp	PWMausgabe		;nein, dann 0 -> PWM
			
			ldi	temp,4			;ServoVollgas
			rcall	HoleParameter		;aus EEProm nach Z
			mov	YL,ZL			;nach Y kopieren
			mov	YH,ZH
			ldi	temp,3			;ServoLeerlauf
			rcall	HoleParameter		;aus EEProm nach Z
			sub	XL,ZL
			sbc	XH,ZH			;in Z jetzt Servogesamtweg in Schritten
			sbiw	ZH:ZL,1			;Totweg ist Leerlauf minus 1
			sub	YL,ZL
			sbc	YH,ZH			;in Y jetzt Servogesamtweg in Schritten
			mov	temp,XH			;in X jetzt Servopos in Schritten
			mov	XH,XL			;Z *256
			clr	XL
			
; Z jetzt durch x rechnen

			ldi	ZL,0xff
			ldi	ZH,0xff
			clr	temp2
			sbiw	YH:YL,1
			brbs	0,Servowegrech2
			adiw	YH:YL,1
Servowegrech1:		adiw	ZH:ZL,1			
			sub	XL,YL			;Differenz
			sbc	XH,YH			;= Servoposition
			sbc	temp,temp2
			brbc	0,Servowegrech1
			mov	XL,ZL
			mov	XH,ZH

;**********************************************************************************************
;Berechen der Pumpenspannung
;**********************************************************************************************
			
Servowegrech2:		ldi	temp,11			;PumpMax
			rcall	HoleParameter		;aus EEProm nach Z
			mov	YL,ZL
			mov	YH,ZH
			ldi	temp,10			;PumpMin
			rcall	HoleParameter		;aus EEProm nach Z
			
			sub	YL,ZL			;Pumpenweg 
			sbc	YH,ZH			;berechen
			lsr	YH
			ror	YL
			lsr	YH	
			ror	YL			;durch 4 dann noch 8 bit

;* Servopos multipliziert mit Pumpenweg		
		
			clr	ZL			; Ergebnisvariable
			clr	ZH			; zuruecksetzen
pr1:			sbiw	YH:YL,1			; test ob 0; 
			brcs	pr3			; Ueberlauf ja, dann pr3	
			
pr2:			add	ZL,XL			; kein Ueberlauf dann addieren von servo
			adc	ZH,XH
			rjmp	pr1			; jetzt Ergebnis  24bit in temp:ZH:ZL
			
;* ergebnis /64	
			
pr3:			lsr	ZH
			ror	ZL
			lsr	ZH
			ror	ZL
			lsr	ZH
			ror	ZL
			lsr	ZH
			ror	ZL
			lsr	ZH
			ror	ZL
			lsr	ZH
			ror	ZL			;Jetzt 10bit Pumpenwer*Servoweg in Z
			mov	YL,ZL
			mov	YH,ZH
			ldi	temp,10			;PumpMin
			rcall	HoleParameter		;aus EEProm nach Z
			add	ZL,YL		
			adc	ZH,YH			;Jetzt 10bit Pumpenspannung in Z
			
;*********************************************************************************************
;* Berechnen der neuen Pumpenspannung
;*********************************************************************************************
			
			lds	XL,PumpeLO		;Pumpenspannung alt holen
			lds	XH,PumpeHI
			sub	XL,ZL			;Sollwert kleiner 
			sbc	XH,ZH			;als Alt
			brbc	0,PWMaus		;dann Ausgabe
			mov	XL,ZL			;Sollwert sichern in X
			mov	XH,ZH
			ldi	temp,8
			rcall	HoleParameter		; Rampenwert holen nach Z
			mov	temp,ZL
			lds	ZL,PumpeLO		;Pumpenspannung alt holen
			lds	ZH,PumpeHI
			clr	YL
			clr	YH
Ramprech1:		add	YL,ZL				
			adc	YH,ZH			; Rampe berechnen
			dec	temp
			brbc	1,Ramprech1		;Rampenwert x Pumpenwert alt
			clr	YL
			add	ZL,YH
			adc	ZH,YL			;= Pumpenwert neu
			mov	YL,XL
			mov	YH,XH			;Sollwert sicherm
			sub	YL,ZL			;Soll noch nicht erreicht
			sbc	YH,ZH			;
			brbc	0,PWMaus		;dann ausgabe
			mov	ZL,XL			;ansonsten Ausgabe des Neuwertes
			mov	ZH,XH
			
PWMaus:			sts	PumpeLO,ZL		;Pumpenspannung sichern
			sts	PumpeHI,ZH
			rcall	PWM_Berech		; PWM berechen					
PWMausgabe:		out	OCR1L,temp		; weil noch 8 bit PWM

			mov	ZL,temp
			clr	ZH
			ldi	sendbuf,LINE4		;Zeile 4	
       			rcall	SendCommand	
			ldi	Sendbuf,' '
			rcall	LCD100er
			rcall	SendText	
			rcall	LCD10er
			rcall	SendText	
			rcall	LCD1er
			rcall	SendText
  
;*********************************************************************************************
;* Menauswahl oder Laufschrift
;*********************************************************************************************

			rcall	Tasterin	
			sbrc	ECU_Status,Men		; Men freigegeben?
			rjmp	Aenderung		; dann rechen
				
Ret:			lds	temp,Taster
			cpi	temp,0x88
			brbc	1,Esc
			lds	temp,Menzeile
			cpi	temp,0
			brbs	1,schluss
			cpi	temp,1
       			brbc	1,Ret1
       			in	temp,PORTB
       			ldi	temp2,8
       			eor	temp,temp2
			out	PORTB,temp
			rjmp	Schluss
Ret1:			ori	ECU_Status,0b00000001			
			rjmp	schluss
Esc:			lds	temp,Taster
			cpi	temp,0x11
			brbc	1,plus
			lds	temp,Menzeile
			clr	temp
			sts	Menzeile,temp
			rjmp	schluss

plus:			lds	temp,Taster
			cpi	temp,0x44
			brbc	1,minus
			lds	temp,Menzeile
			cpi	temp,20
			brbc	1,plus1
			clr	temp
plus1:			inc	temp
			sts	Menzeile,temp
			rjmp	schluss

minus:			lds	temp,Taster
			cpi	temp,0x22
			brbc	1,schluss
			lds	temp,Menzeile
			subi	temp,1
			brbs	1,minus1
			brbs	0,minus1
			sts	Menzeile,temp
			rjmp	schluss
minus1:			ldi	temp,20
			sts	Menzeile,temp

schluss:		lds	temp, Menzeile		; lade Menzeile	
			cpi	temp,0			; ist = 0?
			brbs	1,Lauf			; nein -> Mene anzeigen
			ldi	sendbuf,LINE3		;Zeile 4	
       			rcall	SendCommand	
			lds	temp,Menzeile
			rcall	Textzeile
			ldi	sendbuf,LINE4		;Zeile 4	
       			rcall	SendCommand	
			ldi	Sendbuf,' '		
			rcall	SendText	
			ldi	Sendbuf,' '		
			rcall	SendText	
			ldi	Sendbuf,' '		
			rcall	SendText	
			ldi	Sendbuf,' '		
			rcall	SendText	
			ldi	Sendbuf,' '		
			rcall	SendText	
			ldi	Sendbuf,' '		
			rcall	SendText	
			ldi	Sendbuf,' '		
			rcall	SendText	
			ldi	Sendbuf,' '		
			rjmp	SendText	
			
Lauf:			rcall 	Laufschrift
			ret
			
;*********************************************************************************************
;* Aenderungsmenues fur Parameter
;*********************************************************************************************

Aenderung:		ldi	sendbuf,LINE3		;Zeile 4	
       			rcall	SendCommand		;vom LCD-Display waehlen
			lds	temp,Menzeile
			rcall	Textzeile
			ldi	sendbuf,LINE4		;Zeile 4	
       			rcall	SendCommand		;vom LCD-Display waehlen
			
			lds	temp,Taster
           		cpi	temp,0x11		;Esc
           		brbc	1,Men_RX			;nein, dann Aenderungsmens 
           		andi	ECU_Status,0b11111110	;ja, dann Aenderungsmes aus
			ret
							
Men_RX:		lds	temp,Menzeile		;laden der Menzeile
 			cpi	temp,2
       			brbs	1,Men_RX1		; wenn 2
       			cpi	temp,3
       			brbs	1,Men_RX1		; wenn 3
       			cpi	temp,4
       			brbc	1,Men_RPM			; wenn 2

Men_RX1:		rcall	HoleEEWert
       			rcall	Anzeigems
           		lds	temp,Taster
           		cpi	temp,0x44		;+
           		brbc	1,Men_RX2		;nein, weiter
           		rcall	HoleEEWert
       			adiw	ZH:ZL,1			; erhoehen
           		rjmp	SendEEWert
Men_RX2:		cpi	temp,0x22		;-
           		brbc	1,Men_RX3		;nein, weiter
           		rcall	HoleEEWert
       			sbiw	ZH:ZL,1			;veringern
			rcall	SendEEWert
Men_RX3:		ret			
       			
Men_RPM:       	cpi	temp,5
       			brbs	1,Men_RPM1
			cpi	temp,6
       			brbs	1,Men_RPM1
			cpi	temp,7
       			brbc	1,Men_Wert
       			
Men_RPM1:		rcall	HoleEEWert		;Leerlaufdrehzahl 
			clr	ZH			;laden
			rcall	Anzeigedrehzahl
			lds	temp,Taster
           		cpi	temp,0x44		;+
           		brbc	1,Men_RPM2		;nein, weiter
           		rcall	HoleEEWert		;Leerlaufdrehzahl 
			inc	ZL			; erhoehen
           		rjmp	SendEEWert		;Leerlaufdrehzahl 
Men_RPM2:		cpi	temp,0x22		;-
           		brbc	1,Men_RPM3		;nein, weiter
           		rcall	HoleEEWert		;Leerlaufdrehzahl 
			dec	ZL			; erhoehen
           		rcall	SendEEWert		;Leerlaufdrehzahl 				
Men_RPM3:		ret			
			
Men_Wert: 		cpi	temp,8
       			brbs	1,Men_Wert1
       			cpi	temp,12
       			brbs	1,Men_Wert1
       			cpi	temp,17
       			brbc	1,Men_V
 
Men_Wert1:		rcall	HoleEEWert
			clr	ZH
			ldi	Sendbuf,' '
			rcall	LCD100er
			rcall	SendText	
			rcall	LCD10er
			rcall	SendText	
			rcall	LCD1er
			rcall	SendText
           		ldi	sendbuf,' '		
			rcall	SendText
           		ldi	sendbuf,'x'		
			rcall	SendText
			ldi	sendbuf,'x'		
			rcall	SendText
           		ldi	sendbuf,'x'		
			rcall	SendText

           		lds	temp,Taster
           		cpi	temp,0x44		;+
           		brbc	1,Men_Wert3		;nein, weiter
           		rcall	HoleEEWert
			subi	ZL,-1			; erhoehen
           		andi	ZL,0b00111111		;max 63
           		brbc	1,Men_Wert2
           		ldi	ZL,1
Men_Wert2:       	rjmp	SendEEWert

Men_Wert3:		cpi	temp,0x22		;-
           		brbc	1,Men_Wert5		;nein, weiter
           		rcall	HoleEEWert
			dec	ZL			;veringern
           		brbc	1,Men_Wert4
           		ldi	ZL,63
Men_Wert4:   		rjmp	SendEEWert		
Men_Wert5:		ret
       			
Men_V: 		cpi	temp,9
       			brbs	1,Men_V1
       			cpi	temp,10
       			brbs	1,Men_V1
       			cpi	temp,11
       			brbc	1,Men12
       			
Men_V1:		rcall	HoleEEWert
       			rcall	AnzeigeSpannung		;ausgeben
           		lds	temp,Taster
           		cpi	temp,0x44		;+
           		brbc	1,Men_V2		;nein, weiter
           		rcall	HoleEEWert
       			adiw	ZH:ZL,10		; erhoehen
			rjmp	SendEEWert
Men_V2:		cpi	temp,0x22		;-
           		brbc	1,Men_V3		;nein, weiter
           		rcall	HoleEEWert
       			sbiw	ZH:ZL,10		;veringern
			rcall	SendEEWert
Men_V3:		ret			
      			
Men12:			cpi	temp,12
       			brbc	1,Men13
       		
Men13:			cpi	temp,13
       			brbc	1,Men14
       			rcall	HoleEEWert
       			clr	ZH			;laden
			rcall	AnzeigeTemp		;ausgeben
           		lds	temp,Taster
           		cpi	temp,0x44		;+
           		brbc	1,Men131		;nein, weiter
           		rcall	HoleEEWert
       			inc	ZL			; erhoehen
           		rjmp	SendEEWert
Men131:		cpi	temp,0x22		;-
           		brbc	1,Men132		;nein, weiter
           		rcall	HoleEEWert
       			dec	ZL			;veringern
			rcall	SendEEWert
Men132:		ret

Men14: 		cpi	temp,14
       			brbc	1,Men15
       			rcall	HoleEEWert
       			sei				;Interupt freigeben
			rcall	AnzeigeTemp		;ausgeben
           		lds	temp,Taster
           		cpi	temp,0x44		;+
           		brbc	1,Men141		;nein, weiter
           		rcall	HoleEEWert
       			adiw	ZH:ZL,10			; erhoehen
			rjmp	SendEEWert	
Men141:		cpi	temp,0x22		;-
           		brbc	1,Men142		;nein, weiter
           		rcall	HoleEEWert
       			sbiw	ZH:ZL,10		;veringern
			rcall	SendEEWert
Men142:		ret		
       			
Men15:			cpi	temp,15
       			brbc	1,Men16
       			
Men16:			cpi	temp,16
       			brbc	1,Men18

Men18:			cpi	temp,18
       			brbc	1,Men19
			rcall	HoleEEWert
			rcall	AnzeigeSpannung		;ausgeben
           		lds	temp,Taster
           		cpi	temp,0x44		;+
           		brbc	1,Men181		;nein, weiter
           		rcall	HoleEEWert
       			adiw	ZH:ZL,10		; erhoehen
			rjmp	SendEEWert
Men181:		cpi	temp,0x22		;-
           		brbc	1,Men182		;nein, weiter
           		rcall	HoleEEWert
       			sbiw	ZH:ZL,10		;veringern
			rcall	SendEEWert
Men182:		ret			
          		
Men19:			cpi	temp,19			;Menzeile 19 gewaehlt
       			brbc	1,Men20		;nein
			ldi	sendbuf,'j'		
			rcall	SendText
           		ldi	sendbuf,'a'		
			rcall	SendText
			ldi	sendbuf,' '		
			rcall	SendText
           		ldi	sendbuf,'+'		
			rcall	SendText
			ldi	sendbuf,'/'		
			rcall	SendText
           		ldi	sendbuf,'-'		
			rcall	SendText
          		ldi	sendbuf,' '		
			rcall	SendText		;Taterabfrage
			lds	temp,Taster		
			cpi	temp,0x44		;Taster 3 gedrueckt
			brbs	1,Men191		;ja
			cpi	temp,0x22		;Taster	2
			brbc	1,Men195		;nein
			
Men191:		ldi    	ZH,high(Lieferzustand*2);Startwert indirekte Adressierung
		     	ldi    	ZL,low(Lieferzustand*2)	;Tabelle "Lieferzustand		
			clr	temp			
Men192:    		lpm 				; Zeiche laden nach R0
Men193:        	sbic	EECR,EEWE		
			rjmp	Men193			;Warten auf Schreibfreigabe
			cli
			out	EEAR,temp		;Setzen der Adresse
			out	EEDR,R0			;setzen der Daten
			sbi	EECR,EEMWE		;Schreiben bereit
			;nop
			;nop
			sbi	EECR,EEWE		;Schreiben
			sei
			adiw	ZH:ZL,1			; naechstes Zeichen setzen
	     		inc   	temp			; naechste Speicherstelle
             		cpi	temp,38        		; schon Ende
             		brbc   	1,Men192 		; nein -> nochmal
Men194:        	sbic	EECR,EEWE		; Warten bis schreiben beendet sonst gibts 
			rjmp	Men194			; Probleme im weiteren Programmablauf
			rjmp	Menaus			; Zurueck mit Menbit loeschen
Men195:		ret
			
Men20:			cpi	temp,20
			brbc	1,Menaus
			ldi	sendbuf,'a'		
			rcall	SendText
           		ldi	sendbuf,'n'		
			rcall	SendText
           		lds	temp,Taster
           		in	temp2,PORTC
			bst	temp,5
           		bld	temp2,0
			bst	temp,6
           		bld	temp2,1
			out	PORTC,temp2
			sbrc	temp,7
			rjmp	Gluehrech
			clr	temp
			sts	Gluehwert,temp
			ret
			
Menaus:		andi	ECU_Status,0b11111110
			ret


		